/* inport.c -- An other example of low-level io from userspace                                   */


#include <stdio.h>

#include <asm/types.h>   /* headers for architecture specific data types                         */
#include <unistd.h>      /* contains the prototype for i386 specific ioperm functioni            */
#include <asm/io.h>      /* obviously architecture specific (asm directory) for inb, outb macros */

#define LP_BASE 0x240

int main(void) {

	int portdata,i;
	double avg=0;
	long num = 0;
	int flag=0;

	/* attempt to reserve region in io space */
	if(ioperm(LP_BASE, 3, 1) < 0) {
		fprintf(stderr, "Cannot reserve region in io space, aborting...\n");
		exit(1);
	}

	while (1) {
	  for(i=0;inb(LP_BASE) != 0xFE;i++);
	  avg = (avg*num + (double)i)/(num+1);
	  num++;
	  printf("avg: %f    num: %ld    i: %d \n", avg,num,i);
	  if (num % 20 == 0) {
	    if (avg < 2000) {
	      printf("Signal detected \n");
	      break;
	    }
	    num = 0;
	    avg = 0;
	  }
	}

	/* attempt to release reserved region in io space */
	if(ioperm(LP_BASE, 3, 0) < 0) {
		fprintf(stderr, "Cannot release region in io space, aborting...\n");
		exit(1);
	}

	return(0);  /* just to be nice ;) */

}
